/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FILIALCEP                                               */
/* Tabela : FILIALCEP                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 05/03/2013 - TOMS P. MOURA                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FILIALCEP
BEFORE INSERT OR UPDATE OR DELETE
ON FILIALCEP FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FILIALCEP', '', 'CDPAIS='||:OLD.CDPAIS||';'||'NRCEP='||:OLD.NRCEP||';'||'CDFILIAL='||:OLD.CDFILIAL||';'||'CDLOJA='||:OLD.CDLOJA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FILIALCEP MODIFY DTULTATU DEFAULT SYSDATE
/

UPDATE FILIALCEP SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/