/*
-- ================================================================================
--   Created on    :  20/05/2004
--   Programador   :  Renata Diniz
--  @C:\WIN_V4\SQL\END_CONV\ORACLE\5103_DFSSTPO.SQL
-- ================================================================================
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CALCULA_IMPOSTO' AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

   DROP PROCEDURE CALCULA_IMPOSTO
   GO

CREATE PROCEDURE CALCULA_IMPOSTO
   @P_CDPRODUTO    VARCHAR(10),
   @P_CDEMPRESA    VARCHAR(2),
   @P_CDFILIAL     VARCHAR(4),
   @P_CDCLIENTE    VARCHAR(21),
   @P_CDINSCESTA   VARCHAR(16),
   @P_CDIMPOSTO    VARCHAR(2), /* 'T' - clculo de todos os impostos */
   @P_DTVENDAINI   DATETIME,
   @P_DTVENDAFIN   DATETIME,
   @P_VRPREBRUTO   NUMERIC,
   @P_VRIMPOSTO    NUMERIC OUTPUT

 AS

   DECLARE @V_PAISORIG      VARCHAR(04);
   DECLARE @V_ESTAORIG      VARCHAR(02);
   DECLARE @V_MUNIORIG      VARCHAR(04);
   DECLARE @V_PAISDEST      VARCHAR(04);
   DECLARE @V_ESTADEST      VARCHAR(02);
   DECLARE @V_IDENDCFOP     VARCHAR(01);
   DECLARE @V_IDENDEMIS     VARCHAR(01);
   DECLARE @V_TAXABASECALC  FLOAT;
   DECLARE @V_TAXAALIQUOTA  FLOAT;
   DECLARE @V_BASECALCIT    FLOAT;
   DECLARE @V_IMPOSTOIT     FLOAT;
   DECLARE @V_IMPOSTOTOTAL  FLOAT;
   DECLARE @V_NRALIQTEMP    VARCHAR(14);
   DECLARE @V_PARDEDTMP     FLOAT;
   DECLARE @V_PREDBCTMP     FLOAT;
   DECLARE @V_ALIQUTMP      FLOAT;
   DECLARE @V_CDGRUPOFISC   VARCHAR(03);

   DECLARE @C_CDIMPOTEMP   VARCHAR(02);
   DECLARE @C_CDFISCTEMP   VARCHAR(01);
   DECLARE @C_IDTRATIMPTMP VARCHAR(01);
   DECLARE @C_IDCONSISTENT VARCHAR(01);
   DECLARE @C_IDIMPORECUP  VARCHAR(01);
BEGIN

   SET @V_IMPOSTOTOTAL = 0;

   EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE, '', 'S', '01', @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;

   SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPFIL,'I'))
   FROM FILIAL
   WHERE (CDFILIAL = @P_CDFILIAL);

   IF (@V_IDENDCFOP = 'I') BEGIN
      SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), 
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM INSCRESTAD
      WHERE CDEMPRESA  = @P_CDEMPRESA AND
            CDINSCESTA = @P_CDINSCESTA;
   END ELSE BEGIN
      SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM ENDEFILI
      WHERE (CDFILIAL     = @P_CDFILIAL) AND
            (IDTPENDEFILI = @V_IDENDCFOP);
   END;

   SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'),
          @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
   FROM CLIENTE
   WHERE (CDCLIENTE = @P_CDCLIENTE);

   SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO)
   FROM ENDECLIE
   WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
         (IDTPENDECLIE = @V_IDENDEMIS);

   EXEC CONSULTA_INCIDENCIA 'S', @P_CDEMPRESA, @P_CDPRODUTO, @P_CDINSCESTA, '01', @P_CDFILIAL, '00000', @V_CDGRUPOFISC;

   DECLARE CUR_INCIDENCIA CURSOR FOR
      SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP,
             IDCONSISTENT, IDIMPORECUP
      FROM INCITEMP IT, IMPOSTO IP
      WHERE (IT.NRINCITEMP = @P_CDFILIAL+'00000') AND
            (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
            (IP.IDPRODNOTA = 'P')           AND
            (IP.CDIMPOSTO  = @P_CDIMPOSTO OR @P_CDIMPOSTO = 'T')

   OPEN CUR_INCIDENCIA;
   FETCH NEXT FROM CUR_INCIDENCIA INTO @C_CDIMPOTEMP, @C_CDFISCTEMP, @C_IDTRATIMPTMP,
                                       @C_IDCONSISTENT, @C_IDIMPORECUP;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      EXEC CONSULTA_ALIQUOTA @C_CDIMPOTEMP, 'S', @P_CDEMPRESA, @P_CDPRODUTO, @P_CDINSCESTA, @V_PAISORIG,
                             @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @P_VRPREBRUTO, GETDATE, @P_CDFILIAL, '00000', @V_CDGRUPOFISC;

      SELECT @V_NRALIQTEMP = ISNULL(MAX(NRALIQTEMP),0), @V_PARDEDTMP = ISNULL(MAX(VRPARDEDTMP),0),
             @V_PREDBCTMP = ISNULL(MAX(VRPREDBCTMP),0), @V_ALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
      FROM ALIQTEMP
      WHERE (NRALIQTEMP = @P_CDFILIAL+'00000');

      SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
      SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
      SET @V_BASECALCIT   = @P_VRPREBRUTO * @V_TAXABASECALC;
      SET @V_IMPOSTOIT    = ((@P_VRPREBRUTO * @V_TAXABASECALC) * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

      SET @V_IMPOSTOTOTAL = @V_IMPOSTOTOTAL + @V_IMPOSTOIT;

      DELETE FROM ALIQTEMP
      WHERE NRALIQTEMP = @P_CDFILIAL+'00000';

      FETCH NEXT FROM CUR_INCIDENCIA INTO @C_CDIMPOTEMP, @C_CDFISCTEMP, @C_IDTRATIMPTMP,
                                          @C_IDCONSISTENT, @C_IDIMPORECUP;
   END;
   CLOSE CUR_INCIDENCIA;
   DEALLOCATE CUR_INCIDENCIA;

   DELETE INCITEMP
   WHERE NRINCITEMP = @P_CDFILIAL+'00000';

   SET @P_VRIMPOSTO = @V_IMPOSTOTOTAL;
END;
GO
